



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java——代码复用（组合和继承）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java——代码复用（组合和继承）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-20 08:21:44 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>前言</h2>
<p>“复用代码是Java众多引人注目的功能之一。但要想成为极具革命性的语言，仅仅能够复制代码并对之加以改变是不够的，它必须还能够做更多的事情。” Java解决问题都围绕类展开的，对于复用代码，可以创建新的类来复用，也可以使用别人已经开发并调试好的类。方法的关键在于使用类而不破坏现有程序代码。有两种方式达成此方法的目的：组合和继承。下面将介绍这两种代码重用机制。</p>
<h2>组合和继承的实现</h2>
<p>在新的类中产生现有类的对象，即做组合。该方法只是复用了现有程序代码的功能，而不是它的形式。按照现有类的类型创建新类，无需改变现有类的形式，采用现有类的形式并在其中添加新的代码，此方式就是继承。</p>
<h3>组合的实现</h3>
<p>只需要将对象的引用置于新类中即可。</p>
<pre class="prettyprint linenums"><code>class A{<br />
    ...<br />
}<br />
class B{<br />
    private A;<br />
    ...<br />
}<br />
</code></pre>
<p>在Java中，类中域为基本类型时能够被自动初始化为零，对象引用会被初始化为null。编译器并不是简单地为每一个引用都创建默认对象。若是想初始化对象引用，可以在代码中的下列位置进行：</p>
<ul><li>在定义对象的地方。这也意味着它们会在构造器被调用之前被初始化。</li>
<li>在类的构造器中。</li>
<li>在临近使用这些对象之前，再初始化，这种方式就叫做<code>惰性初始化</code>。</li>
<li>使用实例初始化。</li></ul>
<p>使用《Java编程思想》上面的实例说明：</p>
<pre class="prettyprint linenums"><code>class Soap{<br />
	private String s;<br />
	public Soap() {<br />
		System.out.println(&quot;Soap()无参构造器&quot;);<br />
		s = &quot;Constructed&quot;;		//在类构造器中初始化<br />
	}

	@Override<br />
	public String toString() { return s;}<br />
}

public class Bath {<br />
	private String s1 = &quot;Happy&quot;;//在定义对象的地方初始化<br />
	private Soap castille = new Soap();<br />
	private String s2;<br />
	private int i;

	public Bath() { System.out.println(&quot;Bath() 无参构造器&quot;);}<br />
	//实例初始化<br />
	{<br />
		i = 31;<br />
		System.out.println(&quot;初始化i为31&quot;);<br />
	}

	@Override<br />
	public String toString() {<br />
		if(s2 == null) {		//惰性初始化<br />
			s2 =&quot;Java&quot;;<br />
		}<br />
		return s1 + &quot;\t&quot;+ s2 + &quot;\t&quot; + i + &quot;\t&quot; + castille;<br />
	}

	public static void main(String[] args) {<br />
		System.out.println(new Bath());<br />
	}<br />
}<br />
/*<br />
output:<br />
Soap()无参构造器<br />
初始化i为31<br />
Bath() 无参构造器<br />
Happy	Java	31	Constructed<br />
*/

</code></pre>
<h3>继承的实现</h3>
<p>Java中的继承是使用关键字<code>extends</code>实现的，使用继承子类将会得到父类中所有的域和方法。<b>父类中的私有域和方法将被隐式继承，非私有方法和域将被显式继承。</b>隐式继承也就说可以被间接访问到。</p>
<p>下面将以一个例子说明继承中出现的一些问题。</p>
<pre class="prettyprint linenums"><code>class Person {<br />
	private String name;	//私有域<br />
	public Person() {<br />
		System.out.println(&quot;Person() 无参构造器&quot;);<br />
		name = &quot;noName&quot;;<br />
	}<br />
	public Person(String name) {<br />
		System.out.println(&quot;Person(String name) 带参构造器&quot;);<br />
		this.name  = name;<br />
	}

	public String getName() { return name;}	//让子类可以间接访问到私有域name

	public String toString() { return &quot;Person: &quot;+name; }<br />
}

class Student extends Person{<br />
	public Student() {<br />
		//默认调用 super(); 表示调用父类的无参构造器<br />
		System.out.println(&quot;Student() 无参构造器&quot;);<br />
	}

	public Student(String name) {<br />
		super(name);	//调用父类的带参构造器<br />
		System.out.println(&quot;Student(String name) 带参构造器&quot;);<br />
	}

	public String toString() {	return &quot;Student: &quot; + getName();}<br />
}

public class ExtendsExample {<br />
	public static void main(String[] args) {<br />
		System.out.println(new Student());<br />
		System.out.println(new Student(&quot;sakura&quot;));<br />
	}<br />
}<br />
/*<br />
output：<br />
Person() 无参构造器<br />
Student() 无参构造器<br />
Student: noName<br />
Person(String name) 带参构造器<br />
Student(String name) 带参构造器<br />
Student: sakura<br />
*/<br />
</code></pre>
<p><strong>子类和父类的构造器调用问题</strong></p>
<p>关于构造器的调用顺序在前面<a href="https://www.cnblogs.com/myworld7/p/9977000.html" rel="external nofollow noreferrer">构造方法和匿名对象</a>提过，这里再着重介绍下子类和父类的构造器调用问题。<br>有一个常识问题就是肯定是先有父再有子，那么在程序中也是，应该是现有父类然后才有子类。Java中使用super关键字表示超类也就是父类。若是子类中没有显式调用父类的构造器，那么编译器就会默认调用super()，即父类的默认构造器；若是父类没有默认构造器，则子类中就必须显式调用父类的带参构造器，并且调用必须放在构造器中的第一行！</p>
<p><strong>super()和this()可以同时存在吗？</strong></p>
<p>通过代码可以得知，super()和this()是不能同时出现在构造器中。需要知道，不管怎么样，在子类构造器调用之前一定会先执行父类的构造器。</p>
<h2>组合和继承之间的区别</h2>
<p>组合和继承都允许在新的类中防止子对象，组合是显式这样做，而继承则是隐式这样做。<b>组合技术通常是用于想在新类中使用现有类的功能而非其接口的情况</b>。即，在新类中嵌入某个对象，让其实现所需要的功能；新类的用户看到的只是为新类所定义的接口，而非所嵌入类的接口。<strong>继承是使用某个现有类并开发其特殊版本，会拥有现有类的接口并且可以为新类开发新的接口</strong>。所以，继承关系为“is-a”（是一个），组合关系为“has-a”（有一个）。</p>
<h2>protected关键字</h2>
<p>在实际的项目中，经常会想要将某些事物尽可能对这个世界隐藏起来，但是仍然允许导出类的成员访问它们。<code>protected</code>关键字就是实现这个作用。它表明：对于任何继承于此类的导出类或者任何与此类在同一个包中的类来说，被protected修饰的方法和域是可以访问的，但是对于除这两种类的其他类则是不可访问的。</p>
<h2>继承的局限</h2>
<p>Java中继承的局限便是不允许类似C++那样的多继承，至于为什么没有多继承最直接的原因就为简单编程，不用去考虑父类的父类是谁、父类的父类的父类是谁、以及自己包含的方法继承自谁的。比如B和C继承自A,D又继承B、C，当D调用A中的一个方法时，是继承自B的还是继承自C的呢？</p>
<p>为了实现多继承的效果的话可以使用多层继承（A继承B,B继承C），但是最好不要超过三层，否则代码会太乱。后面会介绍Java使用接口声明的多继承。一个类虽然不能从继承多个基类但是可以声明继承多个接口（interface），从而达到多继承效果。</p>
<h2>小结</h2>
<p>继承和组合都可以从现有类型生成新类型。组合一般是将现有类型作为新类型的底层实现的一部分来加以复用，而继承复用的是接口。在使用继承时，由于导出的类具有基类的接口，因此它可以向上转型至基类，这对后面要介绍的多态是至关重要的。</p>
<p>参考：</p>
<p>《Java编程思想》第四版</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvvo3xq.html">Http client  请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv1v51q.html">MVC 5使用TempData&lpar;对象&rpar;跨视图传递数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2xjvv9.html">解决ArcGIS安装之后出现的Windows installer configures问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q77npeq.html">javascript数据结构-链表</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1pyk2q.html">sort</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gdlxe9.html">hashmap 读取</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q22emoq.html">视图（View） &amp;ndash&semi; ASP&period;NET MVC 4 系列</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q72v319.html">C&plus;&plus;11新特性总结 &lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/390kpd3q.html">fastcgi配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/390l1dn9.html">Bzoj2683 简单题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn6jjpq.html">js模拟下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde2r009.html">sun&period;misc&period;BASE64Encoder是内部专用 API&comma; 可能会在未来发行版中删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz0yve8.html">discuz 插件开发  新手入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ppvvn8.html">oracle HA 高可用性具体解释（之中的一个）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzzye08.html">iOS，Android，&period;NET通用AES加密算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllnym1q.html">SSIS服务无法登录的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv4yj38.html">深入理解linux关闭文件和删除文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q256yn3q.html">python之递归与二分法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9530mmz8.html">Arcgis for JavascriptAPI 常用接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/q77onwjq.html">腾讯云AI平台张文杰：构建一站式机器学习服务平台</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1k1x259.html">记录一次DataTable排序的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp7vlzq.html">c&num;提交事务的两种方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdl50y9.html">ef&period;core  Mysql</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zkyzg9.html">Python（day1）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj3mvr8.html">&lbrack;zt&plus;总结&rsqb;wpf 应用权限问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zlvo59.html">RHEL系统初始化步骤</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyzlzj9.html">php基础-cookie&amp;amp&semi;session</a>
			</li>
						<li><a href="https://www.batexi.com/a/9geo7m48.html">window上杀死node进程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj6rxk9.html">rest&lowbar;framework之权限源码剖析</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp7yvzq.html">&lbrack;LeetCode&rsqb; Magic Squares In Grid 网格中的神奇正方形</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
